> ## Documentation Index
> Fetch the complete documentation index at: https://docs.hookstream.io/llms.txt
> Use this file to discover all available pages before exploring further.

# Create alert rule

Create a new alert rule with notification channels.

` POST /alert-rules `

Create alert rule

Create a new alert rule with notification channels.

## Servers

- ` https://hookstream.io/v1 ` — Production

## Authentication

The operation accepts these alternatives. Schemes within one alternative are required together.

### Alternative 1

- ` apiKey `: ` apiKey `

  - Credential: ` X-API-Key ` in ` header `

  - API key (format: hs_live_<64hex> or hs_test_<64hex>)

### Alternative 2

- ` cookieAuth `: ` apiKey `

  - Credential: ` better-auth.session_token ` in ` cookie `

  - Session cookie (browser auth)

## Request body (required)

Content type: ` application/json `

Request body

- ` value `: type ` object `

  - Required fields: ` name `, ` rule_type `

  - ` name `: type ` string ` — Alert rule name

    - example: ` "High failure rate" `

    - minLength: ` 1 `

  - ` description `: type ` string ` — Optional description

  - ` rule_type `: type ` string ` — Type of alert rule

    - enum: ` ["failure_rate","latency","dlq","volume_drop","issue_opened"] `

    - example: ` "failure_rate" `

  - ` rule_config `: type ` object ` — Rule-type-specific configuration

  - ` source_id `: type ` string ` — Scope to a specific source

  - ` destination_id `: type ` string ` — Scope to a specific destination

  - ` channel_ids `: type ` array ` — Notification channel IDs

    - ` array item `: type ` string `

  - ` cooldown_minutes `: type ` integer ` — Cooldown between alerts (minutes)

    - example: ` 60 `

## Responses

### ` 201 ` — Alert rule created

Content type: ` application/json `

- ` value `: type ` object `

  - Required fields: ` alert_rule `

  - ` alert_rule `: type ` object `; nullable

    - Required fields: ` id `, ` org_id `, ` env_id `, ` name `, ` description `, ` enabled `, ` rule_type `, ` rule_config `, ` source_id `, ` destination_id `, ` channel_ids `, ` cooldown_minutes `, ` last_triggered_at `, ` trigger_count `, ` created_at `, ` updated_at `

    - ` id `: type ` string `

    - ` org_id `: type ` string `

    - ` env_id `: type ` string `

    - ` name `: type ` string `

    - ` description `: type ` string `; nullable

    - ` enabled `: type ` integer `

    - ` rule_type `: type ` string `

    - ` rule_config `: type ` string `

    - ` source_id `: type ` string `; nullable

    - ` destination_id `: type ` string `; nullable

    - ` channel_ids `: type ` string `

    - ` cooldown_minutes `: type ` integer `

    - ` last_triggered_at `: type ` string `; nullable

    - ` trigger_count `: type ` integer `

    - ` created_at `: type ` string `

    - ` updated_at `: type ` string `

### ` 400 ` — Bad request

Content type: ` application/json `

- ` value `: type ` object `

  - Required fields: ` error `

  - ` error `: type ` string ` — Error message

### ` 401 ` — Unauthorized

Content type: ` application/json `

- ` value `: type ` object `

  - Required fields: ` error `

  - ` error `: type ` string ` — Error message

## Request examples

### cURL

```curl
curl -X POST 'https://hookstream.io/v1/alert-rules' \
  -H 'Authorization: Bearer YOUR_API_TOKEN' \
  -H 'Content-Type: application/json' \
  -d '{
  "name": "High failure rate",
  "description": "string",
  "rule_type": "failure_rate",
  "rule_config": {},
  "source_id": "string",
  "destination_id": "string",
  "channel_ids": [
    "string"
  ],
  "cooldown_minutes": 60
}'
```

### JavaScript

```javascript
const response = await fetch('https://hookstream.io/v1/alert-rules', {
  method: 'POST',
  headers: {
      "Authorization": "Bearer YOUR_API_TOKEN",
      "Content-Type": "application/json"
  },
  body: JSON.stringify({
    "name": "High failure rate",
    "description": "string",
    "rule_type": "failure_rate",
    "rule_config": {},
    "source_id": "string",
    "destination_id": "string",
    "channel_ids": [
      "string"
    ],
    "cooldown_minutes": 60
  })
});

const data = await response.json();
console.log(data);
```

### Python

```python
import requests

headers = {
    'Authorization': 'Bearer YOUR_API_TOKEN'
}

response = requests.post('https://hookstream.io/v1/alert-rules', headers=headers, json={
  "name": "High failure rate",
  "description": "string",
  "rule_type": "failure_rate",
  "rule_config": {},
  "source_id": "string",
  "destination_id": "string",
  "channel_ids": [
    "string"
  ],
  "cooldown_minutes": 60
})
print(response.json())
```

### Go

```go
package main

import (
	"fmt"
	"io"
	"net/http"
	"strings"
)

func main() {
	body := strings.NewReader(`{
  "name": "High failure rate",
  "description": "string",
  "rule_type": "failure_rate",
  "rule_config": {},
  "source_id": "string",
  "destination_id": "string",
  "channel_ids": [
    "string"
  ],
  "cooldown_minutes": 60
}`)
	req, _ := http.NewRequest("POST", "https://hookstream.io/v1/alert-rules", body)
	req.Header.Set("Authorization", "Bearer YOUR_API_TOKEN")
	req.Header.Set("Content-Type", "application/json")

	resp, _ := http.DefaultClient.Do(req)
	defer resp.Body.Close()
	result, _ := io.ReadAll(resp.Body)
	fmt.Println(string(result))
}
```